'use strict';

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _sortAny = require('sort-any');

var _sortAny2 = _interopRequireDefault(_sortAny);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const sortDeep = object => {
  if (!Array.isArray(object)) {
    if (!(typeof object === 'object') || object === null) {
      return object;
    }

    return _lodash2.default.mapValues(object, sortDeep);
  }

  return (0, _sortAny2.default)(object.map(sortDeep));
};

module.exports = (chai, utils) => {
  const { Assertion } = chai;
  utils.addMethod(Assertion.prototype, 'equalInAnyOrder', function equalInAnyOrder(b) {
    const a = this.__flags.object;
    const { negate } = this.__flags;
    if (negate) {
      new Assertion(sortDeep(a)).to.not.deep.equal(sortDeep(b));
    } else {
      new Assertion(sortDeep(a)).to.deep.equal(sortDeep(b));
    }
  });
};